
#include <stdio.h>
#include <stdbool.h>
#include <mpi.h>

bool check(int input)
{
  int i;
  bool b[16];

  for(i = 0; i < 16; i++) {
    b[15-i] = (input & 1);    // make binary
    input>>=1;
  }

  return (
    ( b[ 0] ||  b[ 1]) && (!b[ 1] || !b[ 3]) && (b[ 2] ||  b[ 3]) &&
    (!b[ 3] || !b[ 4]) && ( b[ 4] || !b[ 5]) && (b[ 5] || !b[ 6]) &&
    ( b[ 5] ||  b[ 6]) && ( b[ 6] || !b[15]) && (b[ 7] || !b[ 8]) &&
    (!b[ 7] || !b[13]) && ( b[ 8] ||  b[ 9]) && (b[ 8] || !b[ 9]) &&
    (!b[ 9] || !b[10]) && ( b[ 9] ||  b[11]) && (b[10] ||  b[11]) &&
    ( b[12] ||  b[13]) && ( b[13] || !b[14]) && (b[14] ||  b[15])
  );
}

void print_i(int input)
{
  int i;
  bool b[16];

  printf("Found i: %d, ", input);

  for(i = 0; i < 16; i++) {
    b[15-i] = (input & 1);    // make binary
    input>>=1;
  }
  for(i = 0; i < 16; i++)
    printf("%d", (int)b[i]);

  printf("\n");
}


int main(int argc, char *argv[])
{
  int npes, myrank;
  int i, comb;

  MPI_Init(&argc, &argv);

  MPI_Comm_size(MPI_COMM_WORLD, &npes);
  MPI_Comm_rank(MPI_COMM_WORLD, &myrank);

  comb = 1<<16;

  for(i = myrank; i < comb; i+=npes) {
    if(check(i)) {
      print_i(i);
    }
  }

  MPI_Finalize();

  return 0;
}
